<script>
  let name = "";
  let givenTaskName = "";
  let tasks = [];

  const addTask = () => {
    name = givenTaskName;
    givenTaskName = "";
    if (name.length > 0)
      tasks = [...tasks, { name: name, color: "#ff0000", isChecked: false }];
  };

  const deleteTask = (taskToDelete) => {
    tasks = tasks.filter((task) => task.name !== taskToDelete.name);
  };
</script>

<body>
  <main>
    <div class="Container">
      <div>
        <h2 class="progressHeader">
          You've done {tasks.filter((task) => task.isChecked == true).length} out
          of
          {tasks.length} Tasks
        </h2>
      </div>
      <div>
        <input
          placeholder="Add a new task..."
          type="text"
          bind:value={givenTaskName}
          maxlength="50"
        />
        <button class="addBtn" on:click={addTask}>ADD</button>
      </div>
      <table>
        <div class="eachContainer">
          {#each tasks as task, index}
            <tr class="tableContainer">
              <td
                class={`${
                  task.isChecked ? "checked" : "unchecked"
                } taskNameDisplay`}
              >
                {task.name}
              </td>
              <td class="spacer" />
              <td>
                <input
                  id={index}
                  type="checkbox"
                  bind:checked={task.isChecked}
                  name="check"
                /></td
              >
              <td>
                <button
                  class="deleteBtn"
                  name="deleteBtn"
                  on:click={() => deleteTask(task)}>Delete</button
                >
              </td>
            </tr>
          {/each}
        </div>
        <tr class="">
          <td class="typingIn">{givenTaskName}</td>
        </tr>
      </table>
    </div>
  </main>
</body>

<style>
  @import url("https://fonts.googleapis.com/css2?family=Nunito+Sans&display=swap");
  body {
    background-color: #9ca3af;
    height: 100vh;
  }
  .eachContainer {
    overflow-y: scroll;
    max-height: 700px;
  }
  .Container {
    display: flex;
    flex-direction: column;
    justify-self: center;
    align-items: center;
    flex-flow: column wrap;
    height: 100vh;
  }
  * {
    margin: 0;
    font-family: "Nunito Sans", sans-serif;
  }
  button {
    border: solid 3px rgb(229, 229, 229);
  }
  .progressHeader {
    margin: 10px;
  }
  .addBtn {
    height: 3rem;
    width: 7rem;
    background-color: #16a34a;
    color: rgb(231, 231, 231);
  }
  .addBtn:hover {
    background-color: #166534;
    color: rgb(229, 229, 229);
  }
  .deleteBtn {
    background-color: #b91c1c;
    color: #f3f4f6;
  }
  .deleteBtn:hover {
    background-color: #991b1b;
    color: rgb(229, 229, 229);
  }
  .tableContainer {
    display: flex;
    flex-direction: row;
    justify-content: right;
  }
  .typingIn {
    padding-bottom: 1.2rem;
    padding-left: 0.8rem;
    color: #4f4f4f;
  }
  .spacer {
    flex-grow: 1;
  }
  table {
    min-height: 7rem;
    border: solid black 1px;
    margin-top: 10px;
    width: 40vw;
  }
  td {
    margin: 10px;
    font-size: 1.7rem;
  }
  input[type="checkbox"] {
    margin: 10px;
    align-self: right;
    width: 5vw;
    height: 2rem;
  }
  input[type="text"] {
    height: 3rem;
    width: 20rem;
  }
  .taskNameDisplay {
    padding-top: 10px;
  }
  .checked {
    color: #16a34a;
    text-decoration: line-through;
  }
  .unchecked {
    color: #000000;
  }
</style>
